REM :::::
REM ::::: Declare Subroutines
REM :::::
DECLARE SUB CopyFile (SourceFile$, DestFile$)

REM ::::: Init shared Vars and CONSTants
REM :::::
COMMON SHARED ErrorFLG
CONST True = 1, False = 0
ErrorFLG = 0

REM ::::: We'll handle any errors that happen on our own.
REM :::::
ON ERROR GOTO ErrorTrap

REM ::::: Rest of program goes here. This is just a demo that I thought
REM ::::: might also be usefull :-)
REM :::::
PRINT "BOOTBAK.BAS - Demo program for QBasic file copy subroutine. Backs up your"
PRINT "              C:\CONFIG.SYS and C:\AUTOEXEC.BAT  To C:\BOOTBAK\CONFIG.SYS"
PRINT "              and C:\BOOTBAK\AUTOEXEC.BAT"
PRINT
PRINT "Press <ESC> to abort, any other key to continue"
DO
   In$ = INKEY$
LOOP WHILE In$ = ""
IF In$ = CHR$(27) GOTO ExitPrgm
SHELL "C:"
CHDIR "\"
CHDIR "\BOOTBAK"
IF ErrorFLG THEN
   MKDIR "BOOTBAK"
   ErrorFLG = 0
END IF
CHDIR "\BOOTBAK"
CopyFile "C:\CONFIG.SYS", "C:\BOOTBAK\CONFIG.SYS"
ErrorFLG = 0
CopyFile "C:\AUTOEXEC.BAT", "C:\BOOTBAK\AUTOEXEC.BAT"
ErrorFLG = 0

REM ::::: End the program
REM :::::
ExitPrgm:
END


REM ::::: We'll handle and errors by checking the state og the ErrorFLG
REM ::::: variable AFTER any instruction that could cause an error.
REM :::::
ErrorTrap:
ErrorFLG = ERR
RESUME NEXT

SUB CopyFile (SourceFile$, DestFile$)
  
   REM ---------------------------------------------------------------------
   REM ::::: MS-QuickBasic 4.5 code to copy one file to another (overwriting
   REM ::::: the destination if it exists.
   REM :::::
   REM ::::: Authored by Andrew Myers of MatrixWare (bubbajoe@glfn.org)
   REM ::::: May be used freely as long as a credit is given to MatrixWare
   REM ::::: in the program's documentation.
   REM :::::
   REM ::::: SourceFile$ --- The source file's PathName
   REM ::::: DestFile$   --- The destination file's PathName
   REM ---------------------------------------------------------------------
  
   REM ::::: Make sure the source file exists, abort if it doesn't
   REM :::::
   ON ERROR GOTO ErrorTrap
   SourceFileNum = FREEFILE
   OPEN SourceFile$ FOR INPUT AS #SourceFileNum
   IF ErrorFLG > 0 THEN GOTO EndOfCopyFile
   CLOSE #SourceFileNum
  
   REM ::::: Kill (Delete) the destination file if it exists, then
   REM ::::: clear our ErrorFLG variable since it will be set if
   REM ::::: the file does not exist...
   REM :::::
   KILL DestFile$
   ErrorFLG = 0
  
   REM ::::: Open up the source file, Create the destination file
   REM ::::: then, block copy the source to the destination in
   REM ::::: blocks (strings) of up to 32,767 bytes in length
   REM ::::: (32,767 is the max len of a string in QB 4.5)
   REM :::::
   SourceFileNum = FREEFILE
   OPEN SourceFile$ FOR BINARY ACCESS READ AS #SourceFileNum
      DestFileNum = FREEFILE
      OPEN DestFile$ FOR BINARY ACCESS WRITE AS #DestFileNum
         FileLeft& = LOF(SourceFileNum)
        
         REM ::::: The following FOR...NEXT loop copys either:
         REM :::::
         REM :::::    The next 32,767 bytes of the source file
         REM :::::                     -or-
         REM :::::    The remaining part  of the file if there
         REM :::::    are less than 32,767  bytes left to copy
         REM :::::
         FOR X = 1 TO INT(LOF(1) / 32767) + 1
            IF FileLeft& > 32767 THEN
               FileCopyBuffer$ = ""
               FileCopyBuffer$ = STRING$(32767, " ")
               GET #SourceFileNum, X * 32767 - 32766, FileCopyBuffer$
               PUT #DestFileNum, X * 32767 - 32766, FileCopyBuffer$
               FileLeft& = FileLeft& - 32767
               ErrorFLG = 0
            ELSE
               FileCopyBuffer$ = ""
               FileCopyBuffer$ = STRING$(FileLeft&, " ")
               GET #SourceFileNum, X * 32767 - 32766, FileCopyBuffer$
               PUT #DestFileNum, X * 32767 - 32766, FileCopyBuffer$
               ErrorFLG = 0
            END IF
          NEXT X
      CLOSE #DestFileNum
   CLOSE #SourceFileNum
  
   REM ::::: This is the label for aborts to jump to. Note that the ErrorFLG
   REM ::::: will still be set, so you will be able to detect errors in the
   REM ::::: rest of your code and recover correctly.
   REM :::::
EndOfCopyFile:
END SUB

